import numpy as np
import matplotlib.pyplot as plt
import matplotlib.colors as mcolors
from matplotlib.collections import PolyCollection

# 示例数据
x = np.linspace(0, 10, 100)
y = np.sin(x)

# 创建绘图
fig, ax1 = plt.subplots()

# 定义从白到黑的颜色映射
cmap_white_to_black = mcolors.LinearSegmentedColormap.from_list("white_to_black", ["white", "black"])

# 绘制线条
ax1.plot(x, y, color="red", linewidth=2)

# 保持 z 在 0 到 1 的范围内
z = np.linspace(0, 1, len(x))

# 创建多边形的顶点
verts = [np.column_stack([x, y]), np.column_stack([x, np.zeros_like(x)])]
poly = PolyCollection(verts, closed=True, edgecolors='none')

# 将 z 值映射到颜色，并设置 facecolors
poly.set_facecolors(cmap_white_to_black(z))

# 添加多边形到绘图，注意 zorder 参数
ax1.add_collection(poly)
poly.set_zorder(3)  # 提高 zorder 以确保其在其他元素之上

# 调整视图以确保多边形可见
ax1.autoscale()

# 显示图表
plt.show()
